? GNUmakefile
? config.log
? config.status
? contrib/pg_standby/pg_standby
? contrib/pgbench/pgbench
? src/Makefile.global
? src/backend/postgres
? src/backend/catalog/postgres.bki
? src/backend/catalog/postgres.description
? src/backend/catalog/postgres.shdescription
? src/backend/snowball/snowball_create.sql
? src/backend/utils/probes.h
? src/backend/utils/mb/conversion_procs/conversion_create.sql
? src/bin/initdb/initdb
? src/bin/pg_config/pg_config
? src/bin/pg_controldata/pg_controldata
? src/bin/pg_ctl/pg_ctl
? src/bin/pg_dump/pg_dump
? src/bin/pg_dump/pg_dumpall
? src/bin/pg_dump/pg_restore
? src/bin/pg_resetxlog/pg_resetxlog
? src/bin/psql/psql
? src/bin/scripts/clusterdb
? src/bin/scripts/createdb
? src/bin/scripts/createlang
? src/bin/scripts/createuser
? src/bin/scripts/dropdb
? src/bin/scripts/droplang
? src/bin/scripts/dropuser
? src/bin/scripts/reindexdb
? src/bin/scripts/vacuumdb
? src/include/pg_config.h
? src/include/stamp-h
? src/interfaces/ecpg/compatlib/exports.list
? src/interfaces/ecpg/compatlib/libecpg_compat.so.3.1
? src/interfaces/ecpg/ecpglib/exports.list
? src/interfaces/ecpg/ecpglib/libecpg.so.6.1
? src/interfaces/ecpg/include/ecpg_config.h
? src/interfaces/ecpg/include/stamp-h
? src/interfaces/ecpg/pgtypeslib/exports.list
? src/interfaces/ecpg/pgtypeslib/libpgtypes.so.3.1
? src/interfaces/ecpg/preproc/ecpg
? src/interfaces/libpq/exports.list
? src/interfaces/libpq/libpq.so.5.2
? src/port/pg_config_paths.h
? src/test/regress/log
? src/test/regress/pg_regress
? src/test/regress/results
? src/test/regress/testtablespace
? src/test/regress/tmp_check
? src/test/regress/expected/constraints.out
? src/test/regress/expected/copy.out
? src/test/regress/expected/create_function_1.out
? src/test/regress/expected/create_function_2.out
? src/test/regress/expected/largeobject.out
? src/test/regress/expected/largeobject_1.out
? src/test/regress/expected/misc.out
? src/test/regress/expected/tablespace.out
? src/test/regress/sql/constraints.sql
? src/test/regress/sql/copy.sql
? src/test/regress/sql/create_function_1.sql
? src/test/regress/sql/create_function_2.sql
? src/test/regress/sql/largeobject.sql
? src/test/regress/sql/misc.sql
? src/test/regress/sql/tablespace.sql
? src/timezone/zic
Index: src/backend/access/transam/xlog.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/access/transam/xlog.c,v
retrieving revision 1.332
diff -c -r1.332 xlog.c
*** src/backend/access/transam/xlog.c	23 Feb 2009 09:28:49 -0000	1.332
--- src/backend/access/transam/xlog.c	3 Mar 2009 06:38:29 -0000
***************
*** 429,434 ****
--- 429,435 ----
  /*
   * Flag set by interrupt handlers for later service in the redo loop.
   */
+ static volatile sig_atomic_t got_SIGHUP = false;
  static volatile sig_atomic_t shutdown_requested = false;
  /*
   * Flag set when executing a restore command, to tell SIGTERM signal handler
***************
*** 5363,5368 ****
--- 5364,5378 ----
  #endif
  
  				/*
+ 				 * Check if we were requested to re-read config file.
+ 				 */
+ 				if (got_SIGHUP)
+ 				{
+ 					got_SIGHUP = false;
+ 					ProcessConfigFile(PGC_SIGHUP);
+ 				}
+ 
+ 				/*
  				 * Check if we were requested to exit without finishing
  				 * recovery.
  				 */
***************
*** 7641,7646 ****
--- 7651,7663 ----
  }
  
  
+ /* SIGHUP: set flag to re-read config file at next convenient time */
+ static void
+ StartupProcSigHupHandler(SIGNAL_ARGS)
+ {
+ 	got_SIGHUP = true;
+ }
+ 
  /* SIGTERM: set flag to abort redo and exit */
  static void
  StartupProcShutdownHandler(SIGNAL_ARGS)
***************
*** 7667,7673 ****
  	/*
  	 * Properly accept or ignore signals the postmaster might send us
  	 */
! 	pqsignal(SIGHUP, SIG_IGN);	/* ignore config file updates */
  	pqsignal(SIGINT, SIG_IGN);		/* ignore query cancel */
  	pqsignal(SIGTERM, StartupProcShutdownHandler); /* request shutdown */
  	pqsignal(SIGQUIT, startupproc_quickdie);		/* hard crash time */
--- 7684,7690 ----
  	/*
  	 * Properly accept or ignore signals the postmaster might send us
  	 */
! 	pqsignal(SIGHUP, StartupProcSigHupHandler);	/* ignore config file updates */
  	pqsignal(SIGINT, SIG_IGN);		/* ignore query cancel */
  	pqsignal(SIGTERM, StartupProcShutdownHandler); /* request shutdown */
  	pqsignal(SIGQUIT, startupproc_quickdie);		/* hard crash time */
Index: src/backend/postmaster/postmaster.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/postmaster/postmaster.c,v
retrieving revision 1.574
diff -c -r1.574 postmaster.c
*** src/backend/postmaster/postmaster.c	25 Feb 2009 11:07:43 -0000	1.574
--- src/backend/postmaster/postmaster.c	3 Mar 2009 06:38:38 -0000
***************
*** 1949,1954 ****
--- 1949,1956 ----
  				(errmsg("received SIGHUP, reloading configuration files")));
  		ProcessConfigFile(PGC_SIGHUP);
  		SignalChildren(SIGHUP);
+ 		if (StartupPID != 0)
+ 			signal_child(StartupPID, SIGHUP);
  		if (BgWriterPID != 0)
  			signal_child(BgWriterPID, SIGHUP);
  		if (WalWriterPID != 0)